// Licensed to the .NET Foundation under one or more agreements.
// The .NET Foundation licenses this file to you under the MIT license.
// See the LICENSE file in the project root for more information.

/******************************************************************

DO NOT MODIFY. AUTOGENERATED FILE.
This file is generated using the logic from <root>/src/scripts/genEventPipe.py

******************************************************************/

#include "/builddir/build/BUILD/dotnet/src/coreclr/src/vm/common.h"
#include "/builddir/build/BUILD/dotnet/src/coreclr/src/vm/eventpipeprovider.h"
#include "/builddir/build/BUILD/dotnet/src/coreclr/src/vm/eventpipeevent.h"
#include "/builddir/build/BUILD/dotnet/src/coreclr/src/vm/eventpipe.h"

bool ResizeBuffer(char *&buffer, unsigned int& size, unsigned int currLen, unsigned int newSize, bool &fixedBuffer);
bool WriteToBuffer(PCWSTR str, char *&buffer, unsigned int& offset, unsigned int& size, bool &fixedBuffer);
bool WriteToBuffer(const char *str, char *&buffer, unsigned int& offset, unsigned int& size, bool &fixedBuffer);
bool WriteToBuffer(const BYTE *src, unsigned int len, char *&buffer, unsigned int& offset, unsigned int& size, bool &fixedBuffer);

template <typename T>
bool WriteToBuffer(const T &value, char *&buffer, unsigned int& offset, unsigned int& size, bool &fixedBuffer)
{
    if (sizeof(T) + offset > size)
    {
	    if (!ResizeBuffer(buffer, size, offset, size + sizeof(T), fixedBuffer))
		    return false;
    }

    *(T *)(buffer + offset) = value;
    offset += sizeof(T);
    return true;
}

GUID const DotNETRuntimeStressGUID = {0xCC2BCBBA,0x16B6,0x4cf3,{0x89,0x90,0xD7,0x4C,0x2E,0x8A,0xF5,0x00}};
EventPipeProvider *EventPipeProviderDotNETRuntimeStress = nullptr;
EventPipeEvent *EventPipeEventStressLogEvent = nullptr;
EventPipeEvent *EventPipeEventStressLogEvent_V1 = nullptr;
EventPipeEvent *EventPipeEventCLRStackWalkStress = nullptr;
bool EventPipeEventEnabledStressLogEvent()
{
    return EventPipeEventStressLogEvent->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventStressLogEvent(
    const unsigned int Facility,
    const unsigned char LogLevel,
    LPCSTR Message)
{
    if (!EventPipeEventEnabledStressLogEvent())
        return ERROR_SUCCESS;

    char stackBuffer[37];
    char *buffer = stackBuffer;
    unsigned int offset = 0;
    unsigned int size = 37;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(Facility, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(LogLevel, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Message, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventStressLogEvent, (BYTE *)buffer, size);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

bool EventPipeEventEnabledStressLogEvent_V1()
{
    return EventPipeEventStressLogEvent_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventStressLogEvent_V1(
    const unsigned int Facility,
    const unsigned char LogLevel,
    LPCSTR Message,
    const unsigned short ClrInstanceID)
{
    if (!EventPipeEventEnabledStressLogEvent_V1())
        return ERROR_SUCCESS;

    char stackBuffer[39];
    char *buffer = stackBuffer;
    unsigned int offset = 0;
    unsigned int size = 39;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(Facility, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(LogLevel, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Message, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventStressLogEvent_V1, (BYTE *)buffer, size);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

bool EventPipeEventEnabledCLRStackWalkStress()
{
    return EventPipeEventCLRStackWalkStress->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventCLRStackWalkStress(
    const unsigned short ClrInstanceID,
    const unsigned char Reserved1,
    const unsigned char Reserved2,
    const unsigned int FrameCount,
    const void** Stack)
{
    if (!EventPipeEventEnabledCLRStackWalkStress())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    unsigned int offset = 0;
    unsigned int size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Reserved1, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Reserved2, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(FrameCount, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Stack, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventCLRStackWalkStress, (BYTE *)buffer, size);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

extern "C" void InitDotNETRuntimeStress()
{
    EventPipeProviderDotNETRuntimeStress = EventPipe::CreateProvider(DotNETRuntimeStressGUID);
    EventPipeEventStressLogEvent = EventPipeProviderDotNETRuntimeStress->AddEvent(0,0,0,EventPipeEventLevel::Informational);
    EventPipeEventStressLogEvent_V1 = EventPipeProviderDotNETRuntimeStress->AddEvent(0,0,1,EventPipeEventLevel::Informational);
    EventPipeEventCLRStackWalkStress = EventPipeProviderDotNETRuntimeStress->AddEvent(1,1073741824,0,EventPipeEventLevel::LogAlways);
}
